﻿using System;
using System.Net;
using System.IO;
using Avalonia;
using Avalonia.Animation;
using Avalonia.Controls;
using Avalonia.Media;
using Avalonia.Media.Imaging;
using CommunityToolkit.Mvvm.ComponentModel;

namespace 山海奇闻录.ViewModels;

public partial class MainViewModel : ViewModelBase
{
    [ObservableProperty] private string _AppTitle = "山海奇闻录";
    [ObservableProperty] private string _UpLoadTitle = "上传内容库";
    [ObservableProperty] private string _MyValue = "内容上传";
    [ObservableProperty] private string _CloseMyValue = "返回主页";
    [ObservableProperty] private string _Friendly = "社交";
    [ObservableProperty] private string _TextBook = "文案";
    [ObservableProperty] private string _TalkPhotos = "图片";

    [ObservableProperty] private string _DebugText = "调试输出";
    
    [ObservableProperty] private Bitmap? _LogoUrl;
    [ObservableProperty] private Bitmap? _UpLoadUrl;
    
    [ObservableProperty] private Bitmap? _MainImage1;
    [ObservableProperty] private Bitmap? _MainImage2;
    [ObservableProperty] private Bitmap? _MainImage3;
    
    private readonly string _LogoUrlAddr = "https://shanhai.linuxacme.com/logo.png";
    private readonly string _UpLoadUrlAddr = "https://shanhai.linuxacme.com/logo.png";
    private readonly string _MainImage1Addr = "https://shanhai.linuxacme.com/image/2021102818050.jpg";
    private readonly string _MainImage2Addr = "https://shanhai.linuxacme.com/image/2021091109343.jpg";
    private readonly string _MainImage3Addr = "https://shanhai.linuxacme.com/image/210903/210903.jpg";

    // private static readonly HttpClient client = new HttpClient();
    
    public MainViewModel()
    {
        //加载icon
        LoadIcon(_LogoUrlAddr);
        LoadUpLoad(_UpLoadUrlAddr);
        LoadMainImage1(_MainImage1Addr);
        LoadMainImage2(_MainImage2Addr);
        LoadMainImage3(_MainImage3Addr);
    }
    
    private void LoadIcon(string url)
    {
        using (var webClient = new WebClient())
        {
            byte[] imageBytes = webClient.DownloadData(url);
            using (var memoryStream = new MemoryStream(imageBytes))
            {
                LogoUrl = new Bitmap(memoryStream);
            }
        }
    }
    
    private void LoadUpLoad(string url)
    {
        using (var webClient = new WebClient())
        {
            byte[] imageBytes = webClient.DownloadData(url);
            using (var memoryStream = new MemoryStream(imageBytes))
            {
                UpLoadUrl = new Bitmap(memoryStream);
            }
        }
    }
    
    private void LoadMainImage1(string url)
    {
        using (var webClient = new WebClient())
        {
            byte[] imageBytes = webClient.DownloadData(url);
            using (var memoryStream = new MemoryStream(imageBytes))
            {
                MainImage1 = new Bitmap(memoryStream);
            }
        }
    }
    
    private void LoadMainImage2(string url)
    {
        using (var webClient = new WebClient())
        {
            byte[] imageBytes = webClient.DownloadData(url);
            using (var memoryStream = new MemoryStream(imageBytes))
            {
                MainImage2 = new Bitmap(memoryStream);
            }
        }
    }
    
    private void LoadMainImage3(string url)
    {
        using (var webClient = new WebClient())
        {
            byte[] imageBytes = webClient.DownloadData(url);
            using (var memoryStream = new MemoryStream(imageBytes))
            {
                MainImage3 = new Bitmap(memoryStream);
            }
        }
    }
    
    // private async Task Post(string data)
    // {
    //     using (var client = new HttpClient())
    //     {
    //         // 将字符串数据转化为 StringContent
    //         var content = new StringContent(data, Encoding.UTF8, "application/x-www-form-urlencoded");
    //
    //         // 发送请求
    //         var response = await client.PostAsync("https://shanhai.linuxacme.com/Php/PushText.php", content);
    //
    //         // 获取数据
    //         var responseString = await response.Content.ReadAsStringAsync();
    //         DebugText = responseString;
    //     }
    // }
}
